#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll Q;

bool MoSort(pair<ll, ll> a, pair<ll, ll> b) {
	if (a.first / sqrt(Q) != b.first / sqrt(Q)) {
		return a.first < b.first;
	}
	return a.second < b.second;
}

int main() {
	string s;
	cin >> s >> Q;
	vector<pair<ll, ll>> a(Q);
	for (ll i = 0; i < Q; i++) {
		cin >> a[i].first >> a[i].second;
		a[i].first--;
		a[i].second--;
	}
	sort(a.begin(), a.end(), MoSort);
	map<char, ll> numsymb;
	ll l = a[0].first, r = a[0].first;
	numsymb[s[a[0].first]]++;
	for (ll searchans = 0; searchans < Q; searchans++) {
		while (r < a[searchans].second) {
			r++;
			numsymb[s[r]]++;
		}
		while (l < a[searchans].first) {
			numsymb[s[l]]--;
			l++;
		}
		while (r > a[searchans].second) {
			numsymb[s[r]]--;
			r--;
		}
		if (numsymb['C'] % 2 == 0) {
			if (numsymb['O'] != 0) {
				numsymb['O']--;
				numsymb['C']++;
				numsymb['W']++;
			}
			else if(numsymb['W'] != 0) {
				numsymb['W']--;
				numsymb['C']++;
				numsymb['O']++;
			}
			else {
				cout << 'N';
				continue;
			}
		}
		if (numsymb['O'] % 2 + numsymb['W'] % 2 == 0) {
			cout << 'Y';
		}
		else {
			cout << 'N';
		}
	}
	cout << '\n';
}