#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll Q;

bool MoSort(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b) {
	if (a.first.first / sqrt(Q) != b.first.first / sqrt(Q)) {
		return a.first.first < b.first.first;
	}
	return a.first.second < b.first.second;
}

int main() {
	string s;
	cin >> s >> Q;
	vector<pair<pair<ll, ll>, ll>> a(Q);
	for (ll i = 0; i < Q; i++) {
		cin >> a[i].first.first >> a[i].first.second;
		a[i].first.first--;
		a[i].first.second--;
		a[i].second = i;
	}
	vector<char> ans(Q);
	sort(a.begin(), a.end(), MoSort);
	map<char, ll> numsymb;
	ll l = a[0].first.first, r = a[0].first.first;
	numsymb[s[a[0].first.first]]++;
	bool usedW, usedO;
	for (ll searchans = 0; searchans < Q; searchans++) {
		while (r < a[searchans].first.second) {
			r++;
			numsymb[s[r]]++;
		}
		while (l < a[searchans].first.first) {
			numsymb[s[l]]--;
			l++;
		}
		while (r > a[searchans].first.second) {
			numsymb[s[r]]--;
			r--;
		}
		usedW = false; usedO = false;
		if (numsymb['C'] % 2 == 0) {
			if (numsymb['O'] != 0) {
				numsymb['O']--;
				numsymb['C']++;
				numsymb['W']++;
				usedO = true;
			}
			else if(numsymb['W'] != 0) {
				numsymb['W']--;
				numsymb['C']++;
				numsymb['O']++;
				usedW = true;
			}
			else {
				ans[a[searchans].second] = 'N';
				continue;
			}
		}
		if (numsymb['O'] % 2 == 0 && numsymb['W'] % 2 == 0) {
			ans[a[searchans].second] = 'Y';
		}
		else {
			ans[a[searchans].second] = 'N';
		}
		if (usedO) {
			numsymb['O']++;
			numsymb['C']--;
			numsymb['W']--;
		}
		if (usedW) {
			numsymb['W']++;
			numsymb['C']--;
			numsymb['O']--;
		}
	}
	for (ll i = 0; i < Q; i++) {
		cout << ans[i];
	}
	cout << '\n';
}