#include <bits/stdc++.h>
using namespace std;

int n, m;
char v[1001][1001];

bool f(int y, int x, int y0) {
    if (v[y][x] == '#') return true;
    if (v[y][x] == '.') return false;
    v[y][x] = '#';
    bool ans = true;
    if (ans) ans = f(y, x-1, y0);
    if (ans) ans = f(y, x+1, y0);
    if (ans) ans = f(y+1, x, y0);
    if (y > y0) if (ans) ans = f(y-1, x, y0);
    return ans;
}

bool good() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '+') {
                if (!f(i, j, i)) return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    vector <array <int, 2> > a;
    
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
            if (v[i][j] == '.') a.push_back({i, j});
        }
    }

    int ans = 0;
    int s2;
    for (int s = 0; s < (1ll << a.size()); s++) {
        s2 = s;
        for (int i = 0; i < a.size(); i++) {
            if (s2 % 2 == 0) {
                v[a[i][0]][a[i][1]] = '+';
            } else {
                v[a[i][0]][a[i][1]] = '.';
            }
            s2 /= 2;
        }

        if (good()) {
            ans++;
        }
    }
    cout << ans << "\n";
}
