#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using ll = long long;
using ld = long double;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;

    std::vector<int> less{};
    std::vector<int> greater{};

    for (int i = 0; i < n; i++) {
        char type;
        int value;

        std::cin >> type >> value;

        if (type == 'L') {
            less.push_back(value);
        } else {
            greater.push_back(value);
        }
    }

    std::sort(less.begin(), less.end());
    std::sort(greater.begin(), greater.end());

    int result = std::max(less.size(), greater.size());

    for (int i = 0; i < greater.size(); i++) {
        int greater_requirement = greater[i];
        int curr_result = std::distance(less.begin(), lower_bound(less.begin(), less.end(), greater_requirement)) + i;

        result = std::min(result, curr_result);
    }

    std::cout << result << "\n";

    return 0;
}
