#include <bits/stdc++.h>
using namespace std;

const long long D = (1e9+7);

int n, m;
int arr[1005][1005], d[1005][1005];
char inp;
long long ans = 1;

int dfs(int r, int c, int side){
    if (arr[r][c] == -1) return 1;
    arr[r][c] = -1;
    int res = 1;
    if (arr[r+1][c] != -1){
        res *= dfs(r+1, c, 1);
        res %= D;
    }
    if (arr[r-1][c] != -1){
        res *= dfs(r-1, c, 0);
        res %= D;
    }
    if (arr[r][c+1] != -1){
        res *= dfs(r, c+1, 0);
        res %= D;
    }
    if (arr[r][c-1] != -1){
        res *= dfs(r, c-1, 0);
        res %= D;
    }
    if (side == 1) res *= 2;
    res %= D;
    d[r][c] = res;
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++){
            cin >> inp;
            if (inp == '#') arr[i][j] = -1;
        }
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            if (arr[i][j] == -1) continue;
            ans *= (dfs(i, j, 0)+1);
            ans %= D;
        }
    }
    cout << ans;
    return 0;
}









