#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e5;

struct Segment{
    int x_start, y_start, x_end, y_end, cost;

    Segment(){}
    Segment(int x_1, int y_1, int x_2, int y_2){
        x_start = x_1;
        y_start = y_1;
        x_end = x_2;
        y_end = y_2;
        cost = y_end - y_start + x_end - x_start;
    }
} segments[DIM];
Segment create(int x_1, int y_1, int x_2, int y_2){
    Segment res(x_1, y_1, x_2, y_2);
    return res;
}

int q_segm;
int largest[DIM];

bool comp(Segment& A, Segment& B){
    return A.x_start < B.x_start || (A.x_start == B.x_start && A.y_start < B.y_start);
}

bool intersect(Segment& A, Segment& B){
    return A.y_end <= B.y_start && A.x_end <= B.x_start;
}

void input_segm(){
    cin >> q_segm;
    int i = 0, x_1, x_2, y_1, y_2;
    while (i < q_segm){
        cin >> x_1 >> y_1 >> x_2 >> y_2;
        if (abs(x_1 - y_1) >= 10000000 || abs(x_2 - y_2) >= 10000000){
            --q_segm; continue;
        }

        segments[i] = create(x_1, y_1, x_2, y_2);
        ++i;
    }
    sort(segments, segments + q_segm, comp);
}

int largest_subs_of_segm(){
    for (int i = 0; i < q_segm; ++i){
        largest[i] = segments[i].cost;
        for (int j = 0; j < i; ++j)
            if (intersect(segments[j], segments[i]))
                largest[i] = max(largest[i], largest[j] + segments[i].cost);
    }

    int etalon = 0;
    for (int i = 1; i < q_segm; ++i)
        if (largest[etalon] < largest[i])
            etalon = i;
    
    return largest[etalon];
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int side; cin >> side;
    input_segm();

    int res = 2 * side;
    res -= largest_subs_of_segm();
/*
    for (int i = 0; i < q_segm; ++i)
        cout << largest[i] << ' ';
    cout << '\n';
    for (int i = 0; i < q_segm; ++i)
        cout << segments[i].x_start << ' ' << segments[i].y_start << ' ' << segments[i].x_end << ' ' << segments[i].y_end << '\n';
*/
    cout << res << '\n';

    return 0;
}
