#include<iostream>
#include<ios>
#include<vector>
#include<utility>
#include<algorithm>
#include<string>
using namespace std;

string s, ans;
int q;

struct Query {
    int l, r, idx;
};

bool comp(Query a, Query b) {
    return a.l < b.l;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> s >> q;
    vector<Query> queries(q);
    ans.resize(q);
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        queries[i].l = l;
        queries[i].r = r;
        queries[i].idx = i;
    }

    sort(queries.begin(), queries.end(), comp);

    int c = 0, o = 0, w = 0;
    for (int j = queries[0].l; j <= queries[0].r; j++) {
        if (s[j] == 'C') c++;
        if (s[j] == 'O') o++;
        if (s[j] == 'W') w++;
    }
    if (c % 2 != 0 && w % 2 == 0 && o % 2 == 0) ans[queries[0].idx] = 'Y';
    else {
        if (c % 2 == 0 && w % 2 != 0 && o % 2 != 0) ans[queries[0].idx] = 'Y';
        else ans[queries[0].idx] = 'N';
    }

    for (int i = 1; i < q; i++) {
        for (int j = queries[i - 1].l; j <= queries[i].l - 1; j++) {
            if (s[j] == 'C') c--;
            if (s[j] == 'O') o--;
            if (s[j] == 'W') w--;
        }

        if (queries[i].r >= queries[i - 1].r) {
            for (int j = queries[i - 1].r + 1; j <= queries[i].r; j++) {
                if (s[j] == 'C') c++;
                if (s[j] == 'O') o++;
                if (s[j] == 'W') w++;
            }
        }
        else {
            for (int j = queries[i - 1].r; j >= queries[i].r + 1; j--) {
                if (s[j] == 'C') c--;
                if (s[j] == 'O') o--;
                if (s[j] == 'W') w--;
            }
        }

        if (c % 2 != 0 && w % 2 == 0 && o % 2 == 0) ans[queries[i].idx] = 'Y';
        else {
            if (c % 2 == 0 && w % 2 != 0 && o % 2 != 0) ans[queries[i].idx] = 'Y';
            else ans[queries[i].idx] = 'N';
        }
    }

    cout << ans;
}