#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

vector<lli> c;
vector<lli> w;
vector<lli> o;

void solve()
{
    string s;
    cin >> s;
    s = '0' + s;
    lli n = s.size() - 1;
    c.resize(n + 1);
    w.resize(n + 1);
    o.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        c[i] = c[i - 1];
        w[i] = w[i - 1];
        o[i] = o[i - 1];
        if (s[i] == 'C')c[i]++;
        else if (s[i] == 'W')w[i]++;
        else o[i]++;
    }
    lli q;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        lli c1 = c[r] - c[l - 1];
        lli w1 = w[r] - w[l - 1];
        lli o1 = o[r] - o[l - 1];
        if (w1 != o1) {
            cout << "N";
            continue;
        }
        if ((w1 + c1) % 2 != 1)cout << "N";
        else cout << "Y";
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

