#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 2*1e5;
string line;
char ans;
char tree[INF*4];
char build(ll v, ll left, ll right){
    if(left==right){
        tree[v]=line[left];
        return tree[v];
    }
    ll middle = (left+right)/2;
    char first = build(v*2+1, left, middle);
    char second = build(v*2+2, middle+1, right);
    if(first==second) tree[v]='F';
    else if(first=='F') tree[v]=second;
    else if(second=='F') tree[v]=first;
    else if(first!='C' && second!='C') tree[v]='C';
    else if(first!='W' && second!='W') tree[v]='W';
    else tree[v]='O';
    return tree[v];
}
void get(ll v, ll left, ll right, ll l, ll r){
    if(right<l || left>r) return;
    if(left>=l && right<=r){
        char first = ans;
        char second = tree[v];
        if(first==second) ans='F';
        else if(first=='F') ans=second;
        else if(second=='F') ans=first;
        else if(first!='C' && second!='C') ans='C';
        else if(first!='W' && second!='W') ans='W';
        else ans='O';
        return;
    }
    ll middle = (left+right)/2;
    get(v*2+1, left, middle, l, r);
    get(v*2+2, middle+1, right, l, r);
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> line;
    build(0, 0, line.size()-1);
    ll q;
    cin >> q;
    for(ll i = 0; i<q; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        if(first==second){
            if(line[first]=='C') cout << "Y";
            else cout << "N";
            continue;
        }
        ans='F';
        if(line[first]=='W') ans='O';
        else if(line[first]=='O') ans='W';
        first++;
        get(0, 0, line.size()-1, first, second);
        if(ans=='F') cout << "Y";
        else cout << "N";
    }
}