#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 2*1e5+2;
struct node{ll first, second, first1, second1;};
ll minimum;
vector<node> go;
ll tree[INF*4];
vector<pair<ll, ll>> values;
bool cmd(node first, node second){
    if(first.second!=second.second) return first.second>second.second;
    else return first.first>second.first;
}
void update(ll v, ll left, ll right, ll pos, ll value){
    if(right<pos || left>pos) return;
    if(right==left){
        tree[v]=value;
        return;
    }
    ll middle = (left+right)/2;
    update(v*2+1, left, middle, pos, value);
    update(v*2+2, middle+1, right, pos, value);
    tree[v]=min(tree[v*2+1], tree[v*2+2]);
}
void get(ll v, ll left, ll right, ll l, ll r){
    if(right<l || left>r) return;
    if(left>=l && right<=r){
        minimum=min(minimum, tree[v]);
        return;
    }
    ll middle = (left+right)/2;
    get(v*2+1, left, middle, l, r);
    get(v*2+2, middle+1, right, l, r);
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    for(ll i = 0; i<INF*4; i++) tree[i]=1e18;
    values.push_back({0, 0});
    values.push_back({n, n});
    go.push_back({0, 0, -1, -1});
    go.push_back({n, n, -1, -1});
    for(ll i = 0; i<m; i++){
        ll f1, s1, f2, s2;
        cin >> f1 >> s1 >> f2 >> s2;
        values.push_back({f1, s1});
        values.push_back({f2, s2});
        go.push_back({f1, s1, f2, s2});
        go.push_back({f2, s2, -1, -1});
    }
    sort(values.begin(), values.end());
    sort(go.begin(), go.end(), cmd);
    m=go.size();
    for(ll i = 0; i<=m; i++){
        pair<ll, ll> first = {go[i].first, go[i].second};
        pair<ll, ll> second = {go[i].first1, go[i].second1};
        ll pos = lower_bound(values.begin(), values.end(), first)-values.begin();
        if(first.first==n && first.second==n) update(0, 0, m-1, pos, n*2);
        else{
            pair<ll, ll> temp = {first.first, -1e18};
            ll from = lower_bound(values.begin(), values.end(), temp)-values.begin();
            minimum = 1e18;
            get(0, 0, m-1, from, m-1);
            minimum-=first.first+first.second;
            if(second.first==-1) update(0, 0, m-1, pos, minimum+first.first+first.second);
            else{
                ll value = minimum;
                minimum = 1e18;
                ll pos1 = lower_bound(values.begin(), values.end(), second)-values.begin();
                get(0, 0, m-1, pos1, pos1);
                minimum-=second.first+second.second;
                value=min(value, minimum);
                update(0, 0, m-1, pos, value+first.first+first.second);
            }
        }
    }
    minimum = 1e18;
    get(0, 0, m-1, 0, 0);
    cout << minimum << '\n';
}