#pragma GCC optimization("O3")
//#pragma GCC optimization("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, p; cin>>n>>p;
    map<pair<int, int>, pair<int, int>> mpr;
    int x1[p], y1[p], x2[p], y2[p];
    for (int i=0; i<p; i++) {
        cin>>x1[i]>>y1[i]>>x2[i]>>y2[i];
        x1[i]++; y1[i]++; x2[i]++; y2[i]++;
    }

    n++;
    
    vector <int> x, y;
    for (int i=0; i<p; i++) {
        x.push_back(x1[i]);
        x.push_back(x2[i]);
        y.push_back(y1[i]);
        y.push_back(y2[i]);
        mpr[ { x2[i], y2[i] } ] = { x1[i], y1[i] };
    }
    x.push_back(n); y.push_back(n);
    sort (x.begin(), x.end()); sort(y.begin(), y.end());


    vector <int> xx, yy; 
    xx.push_back(x[0]); yy.push_back(y[0]);
    for (int i=1; i<x.size(); i++) {
        if (x[i]!=x[i-1]) xx.push_back(x[i]);
        if (y[i]!=y[i-1]) yy.push_back(y[i]);
    }

    unordered_map <int, int> mpx, mpxr, mpy, mpyr;
    for (int i=0; i<xx.size(); i++) {
        mpx[i] = xx[i];
        mpxr[xx[i]] = i;
    }
    for (int i=0; i<yy.size(); i++) {
        mpy[i] = yy[i];
        mpyr[yy[i]] = i;
    }

    ///////////////////
    /*
    for (int i=0; i<x.size(); i++) cout<<x[i]<<' '; cout<<"\n";
    for (int i=0; i<y.size(); i++) cout<<y[i]<<' '; cout<<"\n";
    for (int i=0; i<xx.size(); i++) cout<<xx[i]<<' '; cout<<"\n";
    for (int i=0; i<yy.size(); i++) cout<<yy[i]<<' '; cout<<"\n";
    */
    ///////////////////

    long long dp[xx.size()][yy.size()];

    int i0 = mpx[0], j0=mpy[0];
    dp[0][0] = i0+j0-2;

    for (int i=1; i<xx.size(); i++) {

        int i1=i, j1=0;
        i1 = mpx[i1]; j1 = mpy[j1];
        //cout<<i1<<' '<<j1<<"   ";

        pair <int, int> p1 = mpr[{i1, j1}];
        dp[i][0] = dp[i-1][0]+i1-mpx[i-1];
        if ( p1.first && p1.second) 
            dp[i][0] = min (dp[i][0], dp[ mpxr[ mpr[ {i1, j1} ].first ] ] [0] ); 
    }
    //cout<<"\n";
    for (int j=1; j<yy.size(); j++) {

        int i1=0, j1=j;
        i1 = mpx[i1]; j1 = mpy[j1];
        //cout<<i1<<' '<<j1<<"   ";

        pair <int, int> p1 = mpr[{i1, j1}];
        dp[0][j] = dp[0][j-1]+j1-mpy[j-1];
        if ( p1.first && p1.second) 
            dp[0][j] = min (dp[0][j], dp [0] [ mpyr[ mpr[ {i1, j1} ].second ] ] ); 
    }
    //cout<<"\n";
   

    for (int i=1; i<xx.size(); i++) {
        
        for (int j=1; j<yy.size(); j++) {

            int i1=i, j1=j;
            i1 = mpx[i1]; j1 = mpy[j1];
            //cout<<i1<<' '<<j1<<"   ";

            pair <int, int> p1 = mpr[{i1, j1}];
            dp[i][j] = min ( dp[i-1][j]+i1-mpx[i-1], dp[i][j-1]+j1-mpy[j-1] );
            if ( p1.first && p1.second ) 
                dp[i][j] = min ( dp[i][j], dp [mpxr [mpr[{i1, j1}].first] ] [mpyr [mpr[{i1, j1}].second] ] ); 
        }
        //cout<<"\n";
    }


    cout<<dp[mpxr[n]][mpyr[n]];

    /*for (int i=0; i<xx.size(); i++) {
        for (int j=0; j<yy.size(); j++)
            cout<<dp[i][j]<<' ';
        cout<<"\n";
    }*/

}