#include <bits/stdc++.h>
using namespace std;

const int P = 1e5+1;
pair<pair<int,int>, pair<int,int>> tramplins[P];

int getResult(int endX, int endY, int p)
{
    int localCounter = -1;
    for (int j = 0; j<p; j++)
    {
        int startX = tramplins[j].first.first;
        int startY = tramplins[j].first.second;
        if (endX <= startX && endY <= startY)
        {
            localCounter += getResult(startX, startY, p);
        }
    }
    return localCounter;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, p;
    cin>>n >> p;
    for (int i = 0; i<p; i++)
    {
        int x1,y1,x2,y2; cin >> x1 >> y1 >> x2 >> y2;
        tramplins[i] = {{x1,y1},{x2,y2}};
    }

    int counter = -1;

    for (int i = 0; i<p; i++)
    {
        int endX = tramplins[i].second.first, endY = tramplins[i].second.second;
        int localCounter = getResult(endX, endY, p);
        
        counter = max(counter, localCounter);
    }
    cout << 2*n - counter;
}
