#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll a, b, c, d, e, f, g;
  ll n, m, k;
  char ch;
  string str;
  cin >> str;
  n = str.size();
  vector<ll> prefix_C(n + 1);
  vector<ll> prefix_O(n + 1);
  vector<ll> prefix_W(n + 1);
  prefix_C[0] = 0;
  prefix_O[0] = 0;
  prefix_W[0] = 0;
  for (ll i = 0; i < n; i++) {
    prefix_C[i + 1] = prefix_C[i];
    prefix_O[i + 1] = prefix_O[i];
    prefix_W[i + 1] = prefix_W[i];
    if (str[i] == 'C') {
      prefix_C[i + 1]++;
    } else if (str[i] == 'O') {
      prefix_O[i + 1]++;
    } else {
      prefix_W[i + 1]++;
    }
  }
  ll q;
  cin >> q;
  while (q--) {
    cin >> a >> b;
    ll C = prefix_C[b] - prefix_C[a - 1];
    ll W = prefix_W[b] - prefix_W[a - 1];
    ll O = prefix_O[b] - prefix_O[a - 1];
    if ((C % 2 == 0 && W % 2 == 1 && O % 2 == 1) ||
        (C % 2 == 1 && W % 2 == 0 && O % 2 == 0)) {
      cout << "Y";
    } else {
      cout << "N";
    }
  }
}