#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

ll get_dist(const pair<ll, ll> &first, const pair<ll, ll> &second) {
  return second.first - first.first + second.second - first.second;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g;
  ll n, m, k;
  char ch;
  string str;
  map<pair<ll, ll>, ll> mp;
  ll p;
  cin >> n >> p;
  vector<pair<pair<ll, ll>, pair<ll, ll>>> trampolines(p + 1); // to-from
  vector<ll> trampoline_answers(p + 1);
  for (ll i = 0; i < p; i++) {
    cin >> trampolines[i].second.first >> trampolines[i].second.second >>
        trampolines[i].first.first >> trampolines[i].first.second;
  }
  trampolines[p] = {{n, n}, {n, n}};
  sort(all(trampolines));
  mp[{0, 0}] = 0;
  for (ll i = 0; i <= p; i++) {
    ll curr_val = trampolines[i].second.first + trampolines[i].second.second;
    for (ll j = 0; j < i; j++) {
      if (trampolines[j].first.first <= trampolines[i].second.first &&
          trampolines[j].first.second <= trampolines[i].second.second) {
        chmyin(curr_val,
               trampoline_answers[j] +
                   get_dist(trampolines[j].first, trampolines[i].second));
      } else if (trampolines[j].second.first <= trampolines[i].second.first &&
                 trampolines[j].second.second <= trampolines[i].second.second) {
        chmyin(curr_val,
               trampoline_answers[j] +
                   get_dist(trampolines[j].second, trampolines[i].second));
      }
    }
    trampoline_answers[i] = curr_val;
  }
  cout << trampoline_answers[p];
}
