#include <iostream>
#include <vector>
#include <queue>
#include <map>

using namespace std;
using ll = long long;


struct cord {
	ll x, y;
};
struct bfs {
	ll x, y, depth;
};

int main() {
	ll N, P, inp1, inp2, inp3, inp4;
	cin >> N >> P;
	map<pair<ll, ll>, pair<ll, ll>> jump;
	for (ll i = 0; i < P; i++) {
		cin >> inp1 >> inp2 >> inp3 >> inp4;
		jump[{inp1, inp2}] = { inp3, inp4 };
	}
	queue<bfs> b;
	bfs push1 = { 0, 0, 0 };
	bfs push2 = { 0, 0, 0 };
	push1.x = 0; push1.y = 0; push1.depth = 0;
	b.push(push1);
	while (!b.empty()) {
		if (b.front().x == N && b.front().y == N) {
			break;
		}
		if (b.front().x + 1 <= N) {
			push1.x = b.front().x + 1; push1.y = b.front().y; push1.depth = b.front().depth + 1;
			if (jump[{push1.x, push1.y}].first != 0 || jump[{push1.x, push1.y}].second != 0) {
				push2.x = jump[{push1.x, push1.y}].first; push2.y = jump[{push1.x, push1.y}].second; push2.depth = push1.depth;
				b.push(push2);
			}
			b.push(push1);
		}
		if (b.front().y + 1 <= N) {
			push1.x = b.front().x; push1.y = b.front().y + 1; push1.depth = b.front().depth + 1;
			if (jump[{push1.x, push1.y}].first != 0 || jump[{push1.x, push1.y}].second != 0) {
				push2.x = jump[{push1.x, push1.y}].first; push2.y = jump[{push1.x, push1.y}].second; push2.depth = push1.depth;
				b.push(push2);
			}
			b.push(push1);
		}
		b.pop();
	}
	cout << b.front().depth << '\n';
}