#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;


struct aaa {
	ll x1, y1, x2, y2, depth, from;
};

bool sorting2(aaa a, aaa b) {
	return a.x2 <= b.x1 && a.y2 <= b.y1;
}

bool sorting1(aaa a, aaa b) {
	if (a.x1 != b.x1) {
		return a.x1 < b.x1;
	}
	return a.y1 < b.y1;
}

int main() {
	ll N, P, min1;
	cin >> N >> P;
	vector<aaa> a(P + 2, { 0, 0, 0, 0, 1000000000000 });
	for (ll i = 1; i <= P; i++) {
		cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
	}
	if (P <= 1000) {
		a[0] = { 0, 0, 0, 0, 0 };
		a[P + 1] = { N, N, N, N, 1000000000000 };
		sort(a.begin(), a.end(), sorting1);
		for (ll i = 1; i <= P + 1; i++) {
			for (ll j = i; j > -1; j--) {
				if (a[j].x2 <= a[i].x1 && a[j].y2 <= a[i].y1) {
					a[i].depth = min(a[i].depth, a[j].depth + a[i].x1 - a[j].x2 + a[i].y1 - a[j].y2);
				}
			}
		}
		cout << a[P + 1].depth << '\n';
	}
	else {
		a[0] = { 0, 0, 0, 0, 0 };
		a[P + 1] = { N, N, N, N, 1000000000000 };
		sort(a.begin(), a.end(), sorting2);
		for (ll i = 1; i <= P + 1; i++) {
			for (ll j = i; j > min1; j--) {
				if (a[j].x2 <= a[i].x1 && a[j].y2 <= a[i].y1) {
					if (a[i].depth > a[j].depth + a[i].x1 - a[j].x2 + a[i].y1 - a[j].y2) {
						a[i].depth = a[j].depth + a[i].x1 - a[j].x2 + a[i].y1 - a[j].y2;
						min1 = a[j].from;
						a[i].from = j;
					}
				}
			}
		}
		cout << a[P + 1].depth << '\n';
	}
}