#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;


/*
two adjacent characters can be swapped
CO -> CCW -> W -> OC
CC -> CC (equal = unchanged when swapped)
C.CO.OW.W
 a  b  c

CCOOWWW -> CCCOWWWW -> CO
CCOOWWW -> 

ooo <-> eee
eoo <-> oee
eeo <-> ooe

COW
oee -> win
eoe -> 
eeo -> 
eoo -> oee -> win


if (2|a) {
    if (2|b) {
        if (2|c) {

        } else {

        }
    } else {
        if (2|c) {

        } else {

        }
    }
} else {
    if (2|b) {
        if (2|c) {
            remove all O and W
            remove all but one C
            win
        } else {

        }
    } else {
        if (2|c) {

        } else {

        }
    }
}

000 <-> 111                 false
001 <-> 010 <-> 110 <-> 101 false
011 <-> 100                 true
*/

vector<bool> outcomes = {
    /* 000 */ false,
    /* 001 */ false,
    /* 010 */ false,
    /* 011 */ true,
    /* 100 */ true,
    /* 101 */ false,
    /* 110 */ false,
    /* 111 */ false,
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string str;
    cin >> str;

    int q;
    cin >> q;

    vector<int> c_counts(str.length() + 1, 0);
    vector<int> o_counts(str.length() + 1, 0);
    vector<int> w_counts(str.length() + 1, 0);

    for (int i = 0; i < str.length(); i++) {
        c_counts[i + 1] = c_counts[i] + (str[i] == 'C');
        o_counts[i + 1] = o_counts[i] + (str[i] == 'O');
        w_counts[i + 1] = w_counts[i] + (str[i] == 'W');
    }

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        int c_count = c_counts[r] - c_counts[l - 1];
        int o_count = o_counts[r] - o_counts[l - 1];
        int w_count = w_counts[r] - w_counts[l - 1];

        int type = 0;

        if (c_count & 1) {
            type += 4;
        }

        if (o_count & 1) {
            type += 2;
        }

        if (w_count & 1) {
            type += 1;
        }

        cout << (outcomes[type] ? 'Y' : 'N');
    }

    cout << "\n";

    return 0;
}
