#include <bits/stdc++.h>
using namespace std;

const long long D = (1e9+7);

int n, m, h, k;
int arr[1005][1005];
char inp;
long long ans = 0;
bool abc;

bool dfs(int r, int c){
    if (r < h || r < 1 || c > m || c < 1) return 0;
    if (arr[r][c] == -1 || arr[r][c] == h) return 0;
    if (r == h) arr[r][c] = -1;
    else arr[r][c] = h;
    abc = dfs(r+1, c);
    abc = dfs(r-1, c);
    abc = dfs(r, c-1);
    abc = dfs(r, c+1);
    return 1;
}

long long binPow(int x, int a, int r){
    if (a == 0) return 1;
    int p = binPow(x, a/2, r);
    if (a%2 == 0) return (p*p)%r;
    return (x*p*p)%r;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++){
            cin >> inp;
            if (inp == '#') arr[i][j] = -1;
        }
    h = 2;
    for (int i = 1; i <= n; i++){
        k = 0;
        h = i;
        for (int j = 1; j <= m; j++){
            if (dfs(i, j)) k++;
        }
        ans += binPow(2, k-1, D);
        ans %= D;
    }
    cout << ans;
    return 0;
}









