#include <bits/stdc++.h>
using namespace std;

const int DIM = 2e5;

struct Vert{
    bool q_C, q_W, q_O;

    Vert(bool C, bool W, bool O){
        q_C = C; q_W = W; q_O = O;
    }
    Vert(){}
};
Vert create(bool C, bool W, bool O){
    Vert res(C, W, O);
    return res;
}
Vert combine(Vert A, Vert B){
    return create(A.q_C ^  B.q_C, A.q_W ^  B.q_W, A.q_O ^  B.q_O);
}

string symbols;
Vert tree[DIM];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> symbols;
    
    tree[0] = create(symbols[0] == 'C', symbols[0] == 'W', symbols[0] == 'O');
    for (int i = 1; i < symbols.size(); ++i)
        tree[i] = combine(tree[i-1], create(symbols[i] == 'C', symbols[i] == 'W', symbols[i] == 'O'));
    
    int q_test; cin >> q_test;
    Vert res;
    for (int i = 0, L, R; i < q_test; ++i){
        cin >> L >> R; --L, --R;
        if (L == 0)
            res = tree[R];
        else
            res = combine(tree[L-1], tree[R]);
        
        if (res.q_C){
            cout << (!(res.q_W || res.q_O) ? 'Y' : 'N');
        }
        else
            cout << ((res.q_W && res.q_O) ? 'Y' : 'N');
    }

    return 0;
}
