#include <bits/stdc++.h>
using namespace std;



bool arr[1005][1005] = {0};

vector<pair<short, pair<short, short>>> V;
vector<short> Ed[800005];

bool used[800005] = {0};
queue<short> Q;

int res_by_height[1005] = {0};

const long long Mod = 1e9 + 7;



void BFS(int start, int height) {
    Q.push(start);
    used[start] = 1;
    short size, next;
    while(Q.size() > 0) {
        size = Ed[Q.front()].size();
        for(int i = 0; i < size; ++i) {
            next = Ed[Q.front()][i];
            if(V[next].first <= height) {
                if(!used[next]) {
                    Q.push(next);
                    used[next] = 1;
                }
            }
        }
        Q.pop();
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    char ch;
    cin>>n >> m;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cin >> ch;
            if(ch == '.') arr[i][j] = 1;
            else arr[i][j] = 0;
        }
    }

    int j0;    
    for(int i = n - 2; i >= 1; --i) {
        for(int j = 1; j < m - 1; ++j) {
            if(arr[i][j]) {
                j0 = j;
                for(j; arr[i][j]; ++j);
                --j;
                V.push_back({n - i - 1, {j0, j}});
                for(j0; j0 <= j and i < n - 2; ++j0) {
                    if(arr[i + 1][j0]) {
                        for(int k = V.size() - 2; V[k].first <= i + 1; --k) {
                            if(V[k].second.first <= j0 and V[k].second.second >= j0) {
                                Ed[V.size() - 1].push_back(k);
                                Ed[k].push_back(V.size() - 1);
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

    short size = V.size(), height= 10000;
    for(int i = size - 1; i >= 0;) {
        for(i; V[i].first == height; --i);
        height = V[i].first;
        int k = i;
        while(k >= 0) {
            for(int j = 0; j < size; ++j) {
                used[j] = 0;
            }
            BFS(k, height);
            for(--k; used[k] and k >= 0; --k);
            ++res_by_height[height];
        }
    }

    for(int i = n - 2; i >= 1; --i) {
        cout << res_by_height[i] << "\n";
    }
    
    /*long long result = 0, sub;
    short cur = 0;
    for(int i = n - 2; i >= 1; --i) {
        cur = res_by_height[i];
        sub = 1;
        for(cur; cur >= 1; --cur) {
            sub *= 2;
            sub %= Mod;
        }
        --sub;
        result += sub;
    }
    ++result;*/

    //cout << result << "\n";
    return 0;
}
