#include <bits/stdc++.h>
#include <math.h>
using namespace std;

// strategy (slow): find the cow whose guess covers the biggest area
// and take them as the truth, then see how many cows do not fit into that area

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int cows[n][2];
    int totalSpotsApprox = n;
    for (int i = 0; i<n; i++) {
        char comp;
        int point;
        cin>>comp>>point;
        cows[i][0] = comp;
        cows[i][1] = point;
        if (point > totalSpotsApprox) {
            totalSpotsApprox = point;
        }
    }
    int greatermostSize = 0;
    int greatermostBegin = 0;
    int greatermostEnd = 0;
    int greatermostIdx = 0;
    for (int i = 0; i<n; i++) {
        char comp = cows[i][0];
        int point = cows[i][1];
        int pointRef = 0;
        if (comp == 'G') {
            pointRef = totalSpotsApprox;
        }
        int size = abs(point - pointRef) + 1;
        if (size > greatermostSize) {
            greatermostSize = size;
            greatermostIdx = i;
            greatermostBegin = pointRef < point ? pointRef : point;
            greatermostEnd = pointRef < point ? point : pointRef;
        }
    }
    int liars = 0;
    for (int i = 0; i<n; i++) {
        if (i == greatermostIdx) {
            continue;
        }
        int point = cows[i][1];
        if (point >= greatermostBegin && point <= greatermostEnd) {
            continue;
        }
        char comp = cows[i][0];
        int pointRef = 0;
        if (comp == 'G') {
            pointRef = totalSpotsApprox;
        }
        if (pointRef >= greatermostBegin && pointRef <= greatermostEnd) {
            continue;
        }
        liars++;
    }
    cout << liars;
}
