#include<iostream>
#include<ios>
#include<vector>
#include<algorithm>
#include<utility>
#include<queue>
using namespace std;
typedef long long ll;

int n, p;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> p;
	vector<vector<int>> g(n + 1, vector<int>(n + 1, 0));
	vector <vector<pair<int, int>>> ramp(n + 1, vector<pair<int, int>>(n + 1, make_pair(0, 0)));
	for (int i = 0; i < p; i++) {
		pair<int, int> s, f;
		cin >> s.first >> s.second >> f.first >> f.second;
		ramp[s.first][s.second] = f;
	}

	int dx[2] = { 1, 0 };
	int dy[2] = { 0, 1 };
	queue<pair<int, int>> q;
	q.push(make_pair(0, 0));
	g[0][0] = 1;
	while (!q.empty()) {
		pair<int, int> curr = q.front();
		q.pop();
		for (int i = 0; i < 2; i++) {
			if (curr.first + dx[i] <= n && curr.second + dy[i] <= n && g[curr.first + dx[i]][curr.second + dy[i]] == 0) {
				q.push(make_pair(curr.first + dx[i], curr.second + dy[i]));
				g[curr.first + dx[i]][curr.second + dy[i]] = g[curr.first][curr.second] + 1;
				int ramp_x = ramp[curr.first + dx[i]][curr.second + dy[i]].first;
				int ramp_y = ramp[curr.first + dx[i]][curr.second + dy[i]].second;
				if (g[ramp_x][ramp_y] == 0) {
					g[ramp_x][ramp_y] = g[curr.first][curr.second] + 1;
					q.push(make_pair(ramp_x, ramp_y));
				}
			}
		}
	}

	cout << g[n][n] - 1;
}