#include<iostream>
#include<ios>
#include<vector>
#include<utility>
#include<queue>
using namespace std;

int n, p;

int main() {

    cin >> n >> p;
    vector<vector<int>> g(n + 1, vector<int>(n + 1, 0));
    vector<pair<int, int>> ramp_x;
    vector<pair<int, int>> ramp_y;
    for (int i = 0; i < p; i++) {
        pair<int, int> x, y;
        cin >> x.first >> y.first >> x.second >> y.second;
        ramp_x.push_back(x);
        ramp_y.push_back(y);
    }

    int dx[2] = { 1, 0 };
    int dy[2] = { 0, 1 };
    queue<pair<int, int>> q;
    q.push(make_pair(0, 0));
    g[0][0] = 1;
    while (!q.empty()) {
        pair<int, int> curr = q.front();
        q.pop();
        for (int i = 0; i < 2; i++) {
            int newX = curr.first + dx[i];
            int newY = curr.second + dy[i];
            if (newX <= n && newY <= n && g[newX][newY] == 0) {
                q.push(make_pair(newX, newY));
                g[newX][newY] = g[curr.first][curr.second] + 1;
                for (int j = 0; j < ramp_x.size(); j++) {
                    if (newX == ramp_x[j].first && newY == ramp_y[j].first) {
                        if (g[ramp_x[j].second][ramp_y[j].second] == 0) {
                            g[ramp_x[j].second][ramp_y[j].second] = g[newX][newY];
                            q.push(make_pair(ramp_x[j].second, ramp_y[j].second));
                        }
                    }
                }
            }
        }
    }

    cout << g[n][n] - 1;
}