#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 1e9+7;
ll dsu[1000];
ll total[1000];
ll level[1000];
ll powers[1001];
bool cmd(pair<ll, ll> first, pair<ll, ll> second){
    if(first.first!=second.first) return first.first>second.first;
    else return first.first<second.first;
}
ll parent(ll v){
    if(dsu[v]==v) return v;
    else{
        ll t = parent(dsu[v]);
        dsu[v]=t;
        return t;
    }
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    powers[0]=1;
    for(ll i = 1; i<1001; i++){powers[i]=powers[i-1]*2; powers[i]%=INF;}
    for(ll i = 0; i<1000; i++) dsu[i]=i;
    ll who[n][m];
    bool table[n][m];
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            char type;
            cin >> type;
            who[i][j]=-1;
            if(type=='.') table[i][j]=true;
            else table[i][j]=false;
        }
    }
    vector<ll> answer;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            if(!table[i][j]) continue;
            vector<pair<ll, ll>> rem;
            queue<pair<ll, ll>> q;
            q.push({i, j});
            while(!q.empty()){
                pair<ll, ll> now = q.front();
                q.pop();
                if(!table[now.first][now.second]) continue;
                table[now.first][now.second]=false;
                rem.push_back(now);
                if(table[now.first-1][now.second]) q.push({now.first-1, now.second});
                if(table[now.first+1][now.second]) q.push({now.first+1, now.second});
                if(table[now.first][now.second-1]) q.push({now.first, now.second-1});
                if(table[now.first][now.second+1]) q.push({now.first, now.second+1});
            }
            sort(rem.begin(), rem.end(), cmd);
            ll now = 0;
            ll helper = 0;
            ll start = rem[0].first;
            ll counter = 1;
            vector<ll> save;
            vector<pair<ll, ll>> save1;
            for(ll k = 0; k<rem.size(); k++){
                save1.push_back(rem[k]);
                if(who[rem[k].first+1][rem[k].second]!=-1) save.push_back(who[rem[k].first+1][rem[k].second]);
                if(k==rem.size()-1 || rem[k+1].first!=rem[k].first || rem[k+1].second!=rem[k].second+1){
                    if(save.size()==0){
                        for(auto element : save1) who[element.first][element.second]=helper;
                        level[helper]=rem[k].first;
                        total[helper]=2;
                        counter=2;
                        helper++;
                        now++;
                        save1.clear();
                    }
                    else{
                        ll forthis = 1;
                        ll prev = parent(save[0]);
                        if(level[prev]==rem[k].first){ forthis*=total[prev]-1; forthis%=INF;}
                        else{ forthis*=total[prev]; forthis%=INF;}
                        for(ll g = 1; g<save.size(); g++){
                            ll here = parent(save[g]);
                            if(here!=prev){
                                if(level[here]==rem[k].first){ forthis*=total[here]-1; forthis%=INF;}
                                else{ forthis*=total[here]; forthis%=INF;}
                                now--;
                                dsu[here]=prev;
                            }
                        }
                        forthis++;
                        forthis%=INF;
                        total[prev]=forthis;
                        level[prev]=rem[k].first;
                        counter=forthis;
                        for(auto element : save1) who[element.first][element.second]=prev;
                        save1.clear();
                        save.clear();
                    }
                }
            }
            for(ll k = 0; k<helper; k++) dsu[k]=k;
            answer.push_back(counter);
        }
    }
    ll ans = 1;
    for(auto element : answer){ans*=element; ans%=INF;}
    cout << ans;
}
/*

3 3
2 2
*/